import java.util.concurrent.TimeoutException;

public class Host {
    private final long timeout; // ^CAEgl
    private boolean ready = false; // \bhsĂ悢Ȃtrue

    public Host(long timeout) {
        this.timeout = timeout;
    }

    // Ԃ̕ύX
    public synchronized void setExecutable(boolean on) {
        ready = on;
        notifyAll();
    }

    // ԂlŎs
    public synchronized void execute() throws InterruptedException, TimeoutException {
        long start = System.currentTimeMillis(); // Jn
        while (!ready) {
            long now = System.currentTimeMillis(); // ݎ
            long rest = timeout - (now - start); // c̑҂
            if (rest <= 0) {
                throw new TimeoutException("now - start = " + (now - start) + ", timeout = " + timeout);
            }
            wait(rest);
        }
        doExecute();
    }

    // ۂ̏
    private void doExecute() {
        System.out.println(Thread.currentThread().getName() + " calls doExecute");
    }
}
