import java.io.IOException;
import java.io.FileWriter;

public class CountupThread extends Thread {
    // JE^̒l
    private long counter = 0;

    // Ivoꂽtrue
    private volatile boolean shutdownRequested = false;

    // Iv
    public void shutdownRequest() {
        shutdownRequested = true;
        interrupt();
    }

    // Ivoꂽǂ̃eXg
    public boolean isShutdownRequested() {
        return shutdownRequested;
    }

    // 
    public void run() {
        try {
            while (!isShutdownRequested()) {
                doWork();
            }
        } catch (InterruptedException e) {
        } finally {
            doShutdown();
        }
    }

    // 
    private void doWork() throws InterruptedException {
        counter++;
        System.out.println("doWork: counter = " + counter);
        Thread.sleep(500);
    }

    // I
    private void doShutdown() {
        System.out.println("doShutdown: counter = " + counter);
        System.out.println("doShutdown: Save BEGIN");
        try {
            FileWriter writer = new FileWriter("counter.txt");
            writer.write("counter = " + counter);
            writer.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        System.out.println("doShutdown: Save END");
    }
}
